local x, y = 350, 350

local A, a = 0, 0

local function angleInRange(a, A1, A2)
  A2 = (A2 - A1) % (2* math.pi)
  a = (a - A1) % (2*math.pi)
  return a <= A2
end

function love.keypressed(k)
  return k == "escape" and love.event.quit()
end

function love.update(dt)
  if love.mouse.isDown(1) then
    A = A - 1*dt
  end
  if love.mouse.isDown(2) then
    A = A + 1*dt
  end
  x, y = love.mouse.getPosition()
  a = math.atan2(y - 300, x - 400)
end

function love.draw()
  love.graphics.setColor(0.5, 0.5, 0.5)
  love.graphics.circle("line", 400, 300, 200)
  love.graphics.setColor(1, 1, 1)
  local A1 = A - math.rad(30)
  local A2 = A + math.rad(30)
  local Ac, As = math.cos(A), math.sin(A)
  love.graphics.line(400, 300, 400 + Ac*600, 300+As*600)
  Ac, As = math.cos(A1), math.sin(A1)
  love.graphics.line(400, 300, 400 + Ac*600, 300+As*600)
  Ac, As = math.cos(A2), math.sin(A2)
  love.graphics.line(400, 300, 400 + Ac*600, 300+As*600)

  if angleInRange(a, A1, A2) then
    love.graphics.setColor(1, 0.5, 0.5)
  else
    love.graphics.setColor(0.5, 0.5, 0.5)
  end
  love.graphics.circle("fill", x, y, 10)
end
